module Manager.ModalManager exposing (..)
-- Own
import Util.Util         exposing (MousePosition)
import Util.ShapeManager exposing (Shape(..))

type Modal
  = NoModal
  | ShowTable
  | ShowInput Shape String String
  | ShowShape Int
  | DrawShape Shape MousePosition

type ModalMsg
  -- show Modal
  = OpenShowTable
  | OpenShowInput
  | OpenShowShape Int
  -- for input / delete Forms
  | Check String
  | Input Char String
  | InputPoint
  | AddShape
  | DeleteShape Int
  -- for drawing shapes - needs refactor
  | OpenDrawShape Shape   

-- Modal Construktors
modalInputConstruktor : String -> Shape -> String -> String -> MousePosition -> Modal
modalInputConstruktor modalType shape x y mouse =
    case modalType of
      "ShowInput" -> ShowInput shape x y
      "DrawShape" -> DrawShape shape mouse
      _           -> NoModal
      -- Operations on Modal
eq_String_Modal : String -> Modal -> Bool
eq_String_Modal string modal = string==(modalNameToString modal)
      -- Get Methods : Parameter of Modal
getInputShapeFromModal : Modal -> Shape
getInputShapeFromModal modal = 
    case modal of
      NoModal             -> Empty
      ShowTable           -> Empty
      ShowInput shape _ _ -> shape
      ShowShape _         -> Empty
      DrawShape shape _   -> shape
getMousePosFromModal : Modal -> MousePosition
getMousePosFromModal modal =
    case modal of
      NoModal           -> {x=0,y=0}
      ShowTable         -> {x=0,y=0}
      ShowInput _ _ _   -> {x=0,y=0}
      ShowShape _       -> {x=0,y=0}
      DrawShape _ mouse -> mouse
      -- Transform Modal to other Types    
modalNameToString : Modal -> String
modalNameToString modal =
    case modal of              
      NoModal         -> "NoModal"
      ShowTable       -> "ShowTable"
      ShowInput _ _ _ -> "ShowInput"
      ShowShape _     -> "ShowShape"
      DrawShape _ _   -> "DrawShape"