module TypeHolder exposing (Model, Msg(..))
-- Http
import Http
-- Browser
import Browser
import Browser.Navigation as Nav
-- Url
import Url
-- Own
import Manager.ModalManager exposing (Modal, ModalMsg)
import Util.ShapeManager exposing (Shape)
import Util.Util         exposing (MousePosition)

type alias Model =
  { modal : Modal
  , saved : List (Shape)
  , svgShapeHover : Int
  , shapesLoadResult : (Result Http.Error String)  
  , url : Url.Url
  , key : Nav.Key
  }  
type Msg
  -- Modal
  = OpenModal ModalMsg
  | OnInputModal ModalMsg String
  | CloseModal
  -- svg 
  | SvgShapeHover Int
  -- for drawing shapes - needs refactor
  | UpdateMousePos MousePosition
  | InputDrawShape
  | SaveAndCloseModal
  -- for loading shapes with http
  | LoadShapes   (Result Http.Error String)
  | ShapesLoaded (Result Http.Error (List Shape))
  -- Url
  | LinkClicked Browser.UrlRequest
  | UrlChanged Url.Url